﻿// LogSig - Logarithmic Signature Utility
// Copyright (C) 2011-2015 Dominik Reichl <info@dominik-reichl.de>

using System;
using System.Collections.Generic;
using System.Text;

using LogSig.DM;
using LogSig.Interfaces;

namespace LogSig.AppModules
{
	public abstract class AppMod
	{
		private Dictionary<string, EventHandler<AppModEventArgs>> m_cmds =
			new Dictionary<string, EventHandler<AppModEventArgs>>();
		public Dictionary<string, EventHandler<AppModEventArgs>> CommandHandlers
		{
			get { return m_cmds; }
		}

		protected void AddCommand(string strCmd, EventHandler<AppModEventArgs> h)
		{
			if(strCmd == null) throw new ArgumentNullException("strCmd");
			if(strCmd.Length == 0) throw new ArgumentException("strCmd");

			m_cmds[strCmd] = h;
		}
	}
}
