﻿// LogSig - Logarithmic Signature Utility
// Copyright (C) 2011-2015 Dominik Reichl <info@dominik-reichl.de>

using System;
using System.Collections.Generic;
using System.Text;

using LogSig.Crypto;
using LogSig.Util;

namespace LogSig.AppModules
{
	public sealed class AppModEventArgs : EventArgs
	{
		private CommandLineArgs m_args;
		public CommandLineArgs Args
		{
			get { return m_args; }
		}

		private CryptoRandomGen m_rand;
		public CryptoRandomGen Random
		{
			get { return m_rand; }
		}

		public AppModEventArgs(CommandLineArgs args)
		{
			if(args == null) throw new ArgumentNullException("args");

			m_args = args;

			string strRand = m_args["rand"];
			if((strRand != null) && strRand.Equals("fast", StrUtil.CaseIgnoreCmp))
				m_rand = new FastRandomGen();
			else m_rand = Program.CryptoRandom;
		}
	}
}
