﻿// LogSig - Logarithmic Signature Utility
// Copyright (C) 2011-2015 Dominik Reichl <info@dominik-reichl.de>

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace LogSig.AppModules
{
	public sealed class AppModRepCases : AppMod
	{
		public AppModRepCases()
		{
			AddCommand("prc3", PrintRepCases3);
		}

		private static void PrintRepCases3(object sender, AppModEventArgs e)
		{
			string[] vProd = new string[] { "id", "a", "b", "c", "ab", "ac", "bc", "abc" };
			int[] vIndices = new int[3];

			do
			{
				if((vIndices.Distinct().Count() == 3) && !vIndices.Contains(0))
				{
					string str1 = vProd[vIndices[0]].ToString();
					string str2 = vProd[vIndices[1]].ToString();
					string str3 = vProd[vIndices[2]].ToString();

					string strW = @"\RepCase{" + str1 + @"}{" + str2 + @"}{" +
						str3 + @"}";
					Console.Write(strW.PadRight(9 + 3 + 2 + 3 + 2 + 3 + 1 + 1));

					Console.WriteLine(@"\RepGen{$\{ \id, " + str1 + ", " + str2 +
						", " + str3 + ", " + str1 + str2 + ", " + str1 + str3 +
						", " + str2 + str3 + ", " + str1 + str2 + str3 + @" \}$}");

					if((str1 + str2) == str3)
						Console.Write(@"\RepDupGen{" + str1 + @"}{" + str2 + @"}{" +
							str3 + @"}");
					else if((str1 + str3) == str2)
						Console.Write(@"\RepDupGen{" + str1 + @"}{" + str3 + @"}{" +
							str2 + @"}");
					else if((str2 + str3) == str1)
						Console.Write(@"\RepDupGen{" + str2 + @"}{" + str3 + @"}{" +
							str1 + @"}");

					Console.WriteLine();
				}

				++vIndices[2];
				if(vIndices[2] == vProd.Length) { vIndices[2] = 0; ++vIndices[1]; }
				if(vIndices[1] == vProd.Length) { vIndices[1] = 0; ++vIndices[0]; }
				if(vIndices[0] == vProd.Length) vIndices[0] = 0;
			}
			while(vIndices.Sum() != 0);
		}
	}
}
