﻿// LogSig - Logarithmic Signature Utility
// Copyright (C) 2011-2015 Dominik Reichl <info@dominik-reichl.de>

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace LogSig.Crypto
{
	public sealed class FastRandomGen : CryptoRandomGen
	{
		private Random m_r = new Random();

		public override void Generate(byte[] pb, int iOffset, int iCount)
		{
			if((iOffset == 0) && (iCount == pb.Length)) m_r.NextBytes(pb);
			else
			{
				byte[] pbRandom = new byte[iCount];
				m_r.NextBytes(pbRandom);
				Array.Copy(pbRandom, 0, pb, iOffset, iCount);
			}
		}

		public override bool GenerateBool()
		{
			return ((m_r.Next() & 1) != 0);
		}

		public override int GenerateInt32(int nExclMax)
		{
			return m_r.Next(nExclMax);
		}
	}
}
