﻿// LogSig - Logarithmic Signature Utility
// Copyright (C) 2011-2015 Dominik Reichl <info@dominik-reichl.de>

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Diagnostics;

using LogSig.DM.SnGroup;

namespace LogSig.DM.AnGroup
{
	public sealed class DmAnGroupElement : DmSnGroupElement,
		IDmGroupElement<DmAnGroupElement>
	{
		public DmAnGroupElement() : base()
		{
		}

		public DmAnGroupElement(int nDegree) : base(nDegree)
		{
			Debug.Assert(this.Sign == 1);
		}

		public DmAnGroupElement(int[] vPerm) : base(vPerm)
		{
			if(this.Sign != 1)
				throw new ArgumentOutOfRangeException("vPerm");
		}

		public bool Equals(DmAnGroupElement other)
		{
			return base.Equals(other as DmSnGroupElement);
		}

		public int CompareTo(DmAnGroupElement other)
		{
			return base.CompareTo(other as DmSnGroupElement);
		}

		public new DmAnGroupElement Clone()
		{
			return new DmAnGroupElement(this.Permutation);
		}

		public new static DmAnGroupElement Parse(string str, int nDegree)
		{
			DmSnGroupElement el = DmSnGroupElement.Parse(str, nDegree);
			return new DmAnGroupElement(el.Permutation);
		}
	}
}
