﻿// LogSig - Logarithmic Signature Utility
// Copyright (C) 2011-2015 Dominik Reichl <info@dominik-reichl.de>

using System;
using System.Collections.Generic;
using System.Text;
using System.Numerics;

namespace LogSig.DM.AnGroup
{
	public sealed class DmAnGroupFactory : IDmGroupFactory
	{
		public object CreateInstance(string strGroup)
		{
			BigInteger? bi = NumUtil.GetPrefixedNumber(strGroup, "Alt");
			if(!bi.HasValue) bi = NumUtil.GetPrefixedNumber(strGroup, "A");
			if(!bi.HasValue) return null;

			return new DmAnGroup(NumUtil.Factorial(bi.Value) / 2);
		}
	}
}
