﻿// LogSig - Logarithmic Signature Utility
// Copyright (C) 2011-2015 Dominik Reichl <info@dominik-reichl.de>

using System;
using System.Collections.Generic;
using System.Text;
using System.Numerics;

namespace LogSig.DM.DihedralGroup
{
	public sealed class DmDihedralGroupFactory : IDmGroupFactory
	{
		public object CreateInstance(string strGroup)
		{
			BigInteger? bi = NumUtil.GetPrefixedNumber(strGroup, "Dih");
			if(!bi.HasValue) bi = NumUtil.GetPrefixedNumber(strGroup, "D");
			if(!bi.HasValue) return null;

			return new DmDihedralGroup(bi.Value);
		}
	}
}
