﻿// LogSig - Logarithmic Signature Utility
// Copyright (C) 2011-2015 Dominik Reichl <info@dominik-reichl.de>

using System;
using System.Collections.Generic;
using System.Text;
using System.Numerics;

namespace LogSig.DM
{
	public interface IDmGroupFactory
	{
		// string Name { get; }

		// /// <summary>
		// /// Short name of the group (e.g. Dih).
		// /// </summary>
		// string ShortName { get; }

		// /// <summary>
		// /// Alternative short name of the group (e.g. Dn).
		// /// </summary>
		// string ShortNameAlt { get; }

		// object CreateInstance(BigInteger biOrder);

		/// <summary>
		/// Try to construct the specified group.
		/// </summary>
		/// <param name="strGroup">Group to construct.</param>
		/// <returns>Returns the constructed group, or <c>null</c> if
		/// the specified group is unsupported.</returns>
		object CreateInstance(string strGroup);
	}
}
