// LogSig - Logarithmic Signature Utility
// Copyright (C) 2011-2015 Dominik Reichl <info@dominik-reichl.de>

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace LogSig.DM.LsGen.GroupImplCaps
{
	public interface IFacPermShuffleTest<T>
		where T : IDmGroupElement<T>
	{
		/// <summary>
		/// Test whether every block shuffle of the input block sequence
		/// is factorization-permuting.
		/// This test is allowed to be one-sided: when it returns <c>true</c>,
		/// every block shuffle is guaranteed to be factorization-
		/// permuting, however when it returns <c>false</c>, a block
		/// shuffle may or may not be factorization-permuting.
		/// </summary>
		bool IsFacPermBlockSeq(List<DmLogSigBlock<T>> lBlocks);
	}
}
