﻿// LogSig - Logarithmic Signature Utility
// Copyright (C) 2011-2015 Dominik Reichl <info@dominik-reichl.de>

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Numerics;
using System.Diagnostics;

namespace LogSig.DM.MultiZnGroup
{
	public sealed class DmMultiZnGroupFactory : IDmGroupFactory
	{
		private static readonly char[] m_vSplit = new char[] { 'x', 'X' };
		public object CreateInstance(string strGroup)
		{
			string[] v = strGroup.Split(m_vSplit, StringSplitOptions.RemoveEmptyEntries);

			BigInteger[] vMods = new BigInteger[v.Length];
			for(int i = 0; i < vMods.Length; ++i)
			{
				BigInteger? pb = NumUtil.GetPrefixedNumber(v[i], "Z");
				if(!pb.HasValue) return null;

				vMods[i] = pb.Value;
			}

			return new DmMultiZnGroup(vMods);
		}
	}
}
