﻿// LogSig - Logarithmic Signature Utility
// Copyright (C) 2011-2015 Dominik Reichl <info@dominik-reichl.de>

using System;
using System.Collections.Generic;
using System.Text;
using System.Numerics;

namespace LogSig.DM.QuaternionGroup
{
	public sealed class DmQuaternionGroupFactory : IDmGroupFactory
	{
		public object CreateInstance(string strGroup)
		{
			BigInteger? bi = NumUtil.GetPrefixedNumber(strGroup, "Quat");
			if(!bi.HasValue) bi = NumUtil.GetPrefixedNumber(strGroup, "Q");
			if(!bi.HasValue) return null;

			return new DmQuaternionGroup(bi.Value);
		}
	}
}
