﻿// LogSig - Logarithmic Signature Utility
// Copyright (C) 2011-2015 Dominik Reichl <info@dominik-reichl.de>

using System;
using System.Collections.Generic;
using System.Text;
using System.Numerics;

namespace LogSig.DM.SnGroup
{
	public sealed class DmSnGroupFactory : IDmGroupFactory
	{
		public object CreateInstance(string strGroup)
		{
			BigInteger? bi = NumUtil.GetPrefixedNumber(strGroup, "Sym");
			if(!bi.HasValue) bi = NumUtil.GetPrefixedNumber(strGroup, "S");
			if(!bi.HasValue) return null;

			return new DmSnGroup(NumUtil.Factorial(bi.Value));
		}
	}
}
