﻿// LogSig - Logarithmic Signature Utility
// Copyright (C) 2011-2015 Dominik Reichl <info@dominik-reichl.de>

using System;
using System.Collections.Generic;
using System.Text;
using System.Numerics;

namespace LogSig.DM.ZnGroup
{
	public sealed class DmZnGroupFactory : IDmGroupFactory
	{
		public object CreateInstance(string strGroup)
		{
			BigInteger? bi = NumUtil.GetPrefixedNumber(strGroup, "C");
			if(!bi.HasValue) bi = NumUtil.GetPrefixedNumber(strGroup, "Z");
			if(!bi.HasValue) return null;

			return new DmZnGroup(bi.Value);
		}
	}
}
