﻿// LogSig - Logarithmic Signature Utility
// Copyright (C) 2011-2015 Dominik Reichl <info@dominik-reichl.de>

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace LogSig.Interfaces
{
	public enum ConstraintType : int
	{
		LE = 1,
		EQ = 3,
		GE = 2,
		FR = 0
	}

	public interface IIlpSolver
	{
		bool AddConstraint(double[] vRow, ConstraintType t, double rh);
		bool SetTypeBinary(int iCol);
		bool SetTypeInt(int iCol);
		double[] Solve();
		int[] SolveInt();
	}
}
