﻿// LogSig - Logarithmic Signature Utility
// Copyright (C) 2011-2015 Dominik Reichl <info@dominik-reichl.de>

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml;
using System.Xml.Serialization;
using System.IO;
using System.Numerics;

using LogSig.DM;

namespace LogSig.Pkc
{
	public static class PkcKeyFile
	{
		public static void Save<T>(Stream sOut, T tObj)
			where T : class
		{
			XmlWriterSettings xws = new XmlWriterSettings();
			xws.Encoding = new UTF8Encoding(false);
			xws.Indent = true;
			xws.IndentChars = "\t";

			XmlWriter xw = XmlWriter.Create(sOut, xws);
			XmlSerializer xs = new XmlSerializer(typeof(T));
			xs.Serialize(xw, tObj);
			xw.Close();
		}

		public static T Load<T>(string strFile)
			where T : class
		{
			T t = null;
			using(FileStream fs = new FileStream(strFile, FileMode.Open,
				FileAccess.Read, FileShare.Read))
			{
				XmlSerializer xs = new XmlSerializer(typeof(T));
				t = (xs.Deserialize(fs) as T);
			}

			return t;
		}
	}
}
