﻿// LogSig - Logarithmic Signature Utility
// Copyright (C) 2011-2015 Dominik Reichl <info@dominik-reichl.de>

using System;
using System.Collections.Generic;
using System.Text;
using System.Xml.Serialization;

using LogSig.DM;

namespace LogSig.Pkc
{
	public class PkcPublicKey
	{
		private string m_strGroup = string.Empty;
		public string Group
		{
			get { return m_strGroup; }
			set
			{
				if(value == null) throw new ArgumentNullException("value");
				m_strGroup = value;
			}
		}

		private string m_strSig = string.Empty;
		public string LogSig
		{
			get { return m_strSig; }
			set
			{
				if(value == null) throw new ArgumentNullException("value");
				m_strSig = value;
			}
		}

		public PkcPublicKey() { }

		public static PkcPublicKey CreatePublic<T>(IDmGroup<T> grp, DmBlockSeq<T> ls)
			where T : IDmGroupElement<T>
		{
			if(grp == null) throw new ArgumentNullException("grp");
			if(ls == null) throw new ArgumentNullException("ls");

			PkcPublicKey pk = new PkcPublicKey();
			pk.Group = grp.Name;
			pk.LogSig = ls.ToString();
			return pk;
		}
	}
}
