﻿// LogSig - Logarithmic Signature Utility
// Copyright (C) 2011-2015 Dominik Reichl <info@dominik-reichl.de>

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using LogSig.Crypto;

namespace LogSig.Test
{
	public static class CryptoTests
	{
		public static void Run()
		{
			TestAesCryptoRandomGen();
		}

		private static void TestAesCryptoRandomGen()
		{
			byte[] pbKey = new byte[32];
			Array.Clear(pbKey, 0, pbKey.Length);

			byte[] pbCtr = new byte[16];
			for(int i = 0; i < 15; ++i) pbCtr[i] = 0xFF;
			pbCtr[15] = 0xFE;

			byte[] pbExp = new byte[32] {
				0x7B, 0xFE, 0x9D, 0x87, 0x6C, 0x6D, 0x63, 0xC1,
				0xD0, 0x35, 0xDA, 0x8F, 0xE2, 0x1C, 0x40, 0x9D,
				0xAC, 0xDA, 0xCE, 0x80, 0x78, 0xA3, 0x2B, 0x1A,
				0x18, 0x2B, 0xFA, 0x49, 0x87, 0xCA, 0x13, 0x47
			};
			byte[] pbGen = new byte[32];

			AesCryptoRandomGen aes = new AesCryptoRandomGen(pbKey, pbCtr);
			aes.Generate(pbGen, 0, pbGen.Length);

			if(!pbExp.SequenceEqual(pbGen))
				throw new Exception("AesCryptoRandomGen");
		}
	}
}
